interface VueEventingOptions {
    instanceMethods?: boolean;
    emitIntegration?: boolean;
}
type Handler = (...args: unknown[]) => unknown;
type EmitFn = (event: string, ...args: unknown[]) => EventingInstance;
interface EventingInstance<T = unknown> {
    $on(event: string, handler: Handler): this;
    $on(events: string[], handler: Handler): this;
    $once(event: string, handler: Handler): this;
    $once(events: string[], handler: Handler): this;
    $off(event: string, handler: Handler): this;
    $off(events: string[], handler: Handler): this;
    $emit: EmitFn;
    $eventbus: Emitter;
}
interface Emitter {
    on(event: string, handler: Handler): void;
    off(event: string, handler: Handler): void;
    emit(event: string, ...args: unknown[]): void;
    reset(event: string): void;
}
declare function MixEventing<T, Args extends []>(base: new (...args: Args) => T): new (...args: Args) => T & EventingInstance<T>;
declare function Eventing<T, Args extends []>(cls: new (...args: Args) => T): new (...args: Args) => T & EventingInstance<T>;
declare function bus(handlers?: Record<string, Handler | Handler[]>): Emitter;
declare function VueEventing({ instanceMethods, emitIntegration }?: VueEventingOptions): void;
export { MixEventing, Eventing, bus, Handler, EmitFn, EventingInstance, Emitter, VueEventing };
